com.trendmicro.ds.network.rest.api

## Interface IHostSSLConfigurationAPI

-     @Path(value="/hosts/{hostID}/intrusion-prevention/ssl-configurations")
       @Produces(value="application/json")
       @Consumes(value="application/json")
      public interface IHostSSLConfigurationAPI

  Management API for host SSL configurations.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `CreateSSLConfigurationResponse` | `createSSLConfiguration(java.lang.String sessionID, java.lang.Integer hostID, CreateSSLConfigurationRequest request)` Create a new SSL configuration.
    `void` | `deleteSSLConfiguration(java.lang.String sessionID, java.lang.Integer hostID, java.lang.Integer sslConfigurationID)` Delete an SSL configuration.
    `DescribeSSLConfigurationResponse` | `describeSSLConfiguration(java.lang.String sessionID, java.lang.Integer hostID, java.lang.Integer sslConfigurationID)` Get details of an SSL configuration.
    `ListSSLConfigurationsResponse` | `listSSLConfigurations(java.lang.String sessionID, java.lang.Integer hostID, java.lang.Integer sslConfigurationID, java.lang.String sslConfigurationIDOp, java.lang.Integer maxItems)` List SSL configurations.
    `ModifySSLConfigurationResponse` | `modifySSLConfiguration(java.lang.String sessionID, java.lang.Integer hostID, java.lang.Integer sslConfigurationID, ModifySSLConfigurationRequest request)` Modify an SSL configuration.

- - ### Method Detail

    - #### createSSLConfiguration

          @POST
          CreateSSLConfigurationResponse createSSLConfiguration(@CookieParam(value="sID")
                                                                      java.lang.String sessionID,
                                                                      @PathParam(value="hostID")
                                                                      java.lang.Integer hostID,
                                                                      CreateSSLConfigurationRequest request)
                                                               throws java.lang.Exception

      Create a new SSL configuration.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API
        `hostID` - the ID of the host for which the new SSL configuration is being created
        `request` - a CreateSSLConfigurationRequest describing the SSL configuration details
      Returns:
        a CreateSSLConfigurationResponse containing the created SSL configuration details
      Throws:
        `java.lang.Exception`

    - #### listSSLConfigurations

          @GET
          ListSSLConfigurationsResponse listSSLConfigurations(@CookieParam(value="sID")
                                                                   java.lang.String sessionID,
                                                                   @PathParam(value="hostID")
                                                                   java.lang.Integer hostID,
                                                                   @QueryParam(value="sslConfigurationID")
                                                                   java.lang.Integer sslConfigurationID,
                                                                   @QueryParam(value="sslConfigurationIDOp")
                                                                   java.lang.String sslConfigurationIDOp,
                                                                   @QueryParam(value="maxItems")
                                                                   java.lang.Integer maxItems)
                                                            throws java.lang.Exception

      List SSL configurations.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API
        `hostID` - the ID of the host for which the SSL configurations are being listed
        `sslConfigurationID` - (optional) used to define the starting point for the query. Combine with `sslConfigurationIDOp` to page through results.
        `sslConfigurationIDOp` - (optional, required if `sslConfigurationID` is specified) Currently supported operations are:
        - gt (greater than)
        - ge (greater than or equal to)
        - eq (equal to)
        - lt (less than)
        - le (less than or equal to)
        `maxItems` - (optional) the maximum number of items to retrieve. The maximum value for this parameter is controlled by the "Maximum number of items to retrieve from database" setting on the administrator account, which defaults to 5000.
      Returns:
        a ListSSLConfigurationResponse containing a list of SSL configurations
      Throws:
        `java.lang.Exception`

    - #### describeSSLConfiguration

          @GET
           @Path(value="{id}")
          DescribeSSLConfigurationResponse describeSSLConfiguration(@CookieParam(value="sID")
                                                                                              java.lang.String sessionID,
                                                                                              @PathParam(value="hostID")
                                                                                              java.lang.Integer hostID,
                                                                                              @PathParam(value="id")
                                                                                              java.lang.Integer sslConfigurationID)
                                                                                       throws java.lang.Exception

      Get details of an SSL configuration.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API
        `hostID` - the ID of the host to which the SSL configuration belongs
        `sslConfigurationID` - the SSL configuration ID
      Returns:
        an SSLConfiguration object with the SSL configuration details
      Throws:
        `java.lang.Exception`

    - #### modifySSLConfiguration

          @POST
           @Path(value="{id}")
          ModifySSLConfigurationResponse modifySSLConfiguration(@CookieParam(value="sID")
                                                                                           java.lang.String sessionID,
                                                                                           @PathParam(value="hostID")
                                                                                           java.lang.Integer hostID,
                                                                                           @PathParam(value="id")
                                                                                           java.lang.Integer sslConfigurationID,
                                                                                           ModifySSLConfigurationRequest request)
                                                                                    throws java.lang.Exception

      Modify an SSL configuration.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API
        `hostID` - the ID of the host to which the SSL configuration belongs
        `sslConfigurationID` - the SSL configuration ID
        `request` - the ModifySSLConfigurationRequest containing the updated SSL configuration details
      Returns:
        a ModifySSLConfigurationResponse containing the updated SSL configuration
      Throws:
        `java.lang.Exception`

    - #### deleteSSLConfiguration

          @DELETE
           @Path(value="{id}")
          void deleteSSLConfiguration(@CookieParam(value="sID")
                                                                   java.lang.String sessionID,
                                                                   @PathParam(value="hostID")
                                                                   java.lang.Integer hostID,
                                                                   @PathParam(value="id")
                                                                   java.lang.Integer sslConfigurationID)
                                                            throws java.lang.Exception

      Delete an SSL configuration.
      Parameters:
        `sessionID` - a session ID returned by the Authentication API
        `hostID` - the ID of the host to which the SSL configuration belongs
      Throws:
        `java.lang.Exception`

Copyright © 2017 Trend Micro Inc. All Rights Reserved.